// SRFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SRFile.h"
#include "SRFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRFileDlg dialog

CSRFileDlg::CSRFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSRFileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSRFileDlg)
	m_servport = 0;
	m_listenport = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSRFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSRFileDlg)
	DDX_Control(pDX, IDC_IPADDRESS1, m_ipctrl);
	DDX_Text(pDX, IDC_EDIT1, m_servport);
	DDX_Text(pDX, IDC_EDIT2, m_listenport);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSRFileDlg, CDialog)
	//{{AFX_MSG_MAP(CSRFileDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnBtnRecv)
	ON_BN_CLICKED(IDC_BUTTON2, OnBtnSend)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSRFileDlg message handlers

BOOL CSRFileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSRFileDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSRFileDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSRFileDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

#include <windows.h>
#include <winsock2.h>
#include <stdio.h>

void CSRFileDlg::OnBtnSend() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	SOCKET s = WSASocket(AF_INET, SOCK_STREAM, 0, 0, 0, WSA_FLAG_OVERLAPPED);
	HANDLE hEvent = CreateEvent(0, TRUE, FALSE, 0);
	SOCKADDR_IN sinaddr;
	int sinaddrlen = sizeof(sinaddr);
	ZeroMemory(&sinaddr, sinaddrlen);
	sinaddr.sin_addr.s_addr = INADDR_ANY;
	sinaddr.sin_port = htons(m_listenport);
	sinaddr.sin_family = PF_INET;
	bind(s, (SOCKADDR*)&sinaddr, sinaddrlen);
	listen(s, 5);

	WSAEventSelect(s, (WSAEVENT)hEvent, FD_ACCEPT);
	if (MsgWaitEvent(hEvent) == 0)
		goto quit;
	ResetEvent(hEvent);

	{
		SOCKET ns = accept(s, (SOCKADDR*)&sinaddr, &sinaddrlen);
		closesocket(s);
		s = ns;
		FILE* fp = fopen("c:\\1.dat", "rb");
		for(;;) {
			char buf[1024];
			int buflen = fread(buf, 1, 1024, fp);
			if (buflen > 0) {
				WSAEventSelect(s, (WSAEVENT)hEvent, FD_WRITE);
				if (MsgWaitEvent(hEvent) == 0)
					break;
				ResetEvent(hEvent);
				send(s, buf, buflen, 0);
			} else
				break;
		}
		fclose(fp);
	}
quit:
	closesocket(s);
	CloseHandle(hEvent);
	AfxMessageBox(_T(""));
}

void CSRFileDlg::OnBtnRecv() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	SOCKET s = WSASocket(AF_INET, SOCK_STREAM, 0, 0, 0, WSA_FLAG_OVERLAPPED);
	HANDLE hEvent = CreateEvent(0, TRUE, FALSE, 0);
	SOCKADDR_IN sinaddr;
	CString strIP;
	BYTE a, b, c, d;
	m_ipctrl.GetAddress(a, b, c, d);
	strIP.Format("%d.%d.%d.%d", a, b, c, d);
	ZeroMemory(&sinaddr, sizeof(sinaddr));
	sinaddr.sin_family = PF_INET;
	sinaddr.sin_port = htons(m_servport);
	sinaddr.sin_addr.s_addr = inet_addr(strIP);
	connect(s, (SOCKADDR*)&sinaddr, sizeof(sinaddr));
	WSAEventSelect(s, (WSAEVENT)hEvent, FD_CONNECT);

	if (MsgWaitEvent(hEvent) == 0)
		return;
	ResetEvent(hEvent);

	FILE* fp = fopen("c:\\2.dat", "wb");
	for(;;) {
		char buf[1024];
		WSAEventSelect(s, (WSAEVENT)hEvent, FD_READ | FD_CLOSE);
		if (MsgWaitEvent(hEvent) == 0)
			break;
		WSANETWORKEVENTS wsaevents;
		WSAEnumNetworkEvents(s, hEvent, &wsaevents);
		ResetEvent(hEvent);
		if (wsaevents.lNetworkEvents & FD_READ) {
			int r = recv(s, buf, 1024, 0);
			if (r > 0) {
				fwrite(buf, 1, r, fp);
			} else {
				AfxMessageBox(_T("չз˴"));
				break;
			}
		} else if (wsaevents.lNetworkEvents & FD_CLOSE) {
			AfxMessageBox(_T(""));
			break;
		}
	}
	fclose(fp);
	closesocket(s);
	CloseHandle(hEvent);
}

DWORD CSRFileDlg::MsgWaitEvent(HANDLE hEvent)
{
	for(;;) {
		HANDLE hArr = hEvent;
		DWORD ret = MsgWaitForMultipleObjects(1, &hArr, FALSE, INFINITE, QS_ALLINPUT);
		if (ret == WAIT_OBJECT_0) {
			return 1;
		} else if (ret == WAIT_OBJECT_0 + 1) {
			MSG msg;
			while(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
				if (AfxGetApp()->PumpMessage() == FALSE)
					return 0;
		}
	}
}

void CSRFileDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	PostQuitMessage(0);
	CDialog::OnClose();
}

void CSRFileDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	// TODO: Add your message handler code here
	
}
